## compiz 0.9.7.6

=== plugins/decor/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)
include (CompizCommon)

include_directories (${CMAKE_CURRENT_SOURCE_DIR}/src/clip-groups/include/)

compiz_plugin(decor PLUGINDEPS composite opengl LIBRARIES decoration compiz_decor_clip_groups)

add_subdirectory (src/clip-groups)

if (COMPIZ_BUILD_WITH_RPATH AND NOT COMPIZ_DISABLE_PLUGIN_DECOR)

    set_target_properties (
	decor PROPERTIES
	INSTALL_RPATH "${COMPIZ_LIBDIR}"
    )
endif (COMPIZ_BUILD_WITH_RPATH AND NOT COMPIZ_DISABLE_PLUGIN_DECOR)

=== plugins/opengl/CMakeLists.txt ===
find_package (Compiz REQUIRED)

include (CompizPlugin)

find_package (OpenGL)
if (OPENGL_FOUND)
    compiz_plugin(opengl PLUGINDEPS composite LIBRARIES ${OPENGL_gl_LIBRARY} INCDIRS ${OPENGL_INCLUDE_DIR})
endif ()

=== debian/changelog ===
compiz (1:0.9.7.6-0ubuntu1) precise; urgency=low

  [ Didier Roche ]
  * New upstream release:
    - Memory leak in dlloaderListPlugins (LP: #968985)
    - priv->invisible is not updated when the window is mapped (LP: #969102)
    - window management, multi-monitor - In multi-monitor environment, windows
      should spread on the monitor in which they reside (LP: #919139)
    - Drop-down menus look disembodied from their titles (LP: #659816)
    - Improve performace of the shadow clipping code (LP: #931883)
    - DecorWindow::computeShadowRegion called way too much (LP: #969101)
    - white box randomly shows up at top left corner blocking application
      from using stuff under it (LP: #940603)
  * Rebuild against latest metacity to get the HUD key configuration
    exposed in unity 3D as well (LP: #969256)
  * debian/patches/ubuntu-config.patch:
    - set multioutput_mode to all outputs (windows to be scaled on each the
      monitor they are on only) (LP: #919139)
  * debian/patches/fix_976467.patch:
    - Fix shadows being clipped incorrectly (LP: #976467)

  [ Oliver Grawert ]
  * update the GLES2 patch for the new upstream release.

 -- Didier Roche <didrocks@ubuntu.com>  Wed, 11 Apr 2012 18:35:39 +0200

compiz (1:0.9.7.4-0ubuntu3) precise; urgency=low

  * fix typo in copying of the cmake files, so FindOpenGLES2.cmake ends up in
    the right place for other packages (i.e. compiz-plugins-main on GLES2
    capable arches)
  * make copying the GLES2 cmake file architecture specifc instead of ignoring
    if it is not found on arches that do not have it.

 -- Oliver Grawert <ogra@ubuntu.com>  Fri, 06 Apr 2012 13:55:13 +0200

compiz (1:0.9.7.4-0ubuntu2) precise; urgency=low

  * enable Linaros compiz-package-gles2.patch for armhf(/el) builds, thanks
    to Alexandros Frantzis <alexandros.frantzis@linaro.org> for creating it.
  * enable quilt in debian/rules
  * apply patches based on debian architecture via series.<arch> file
    (stolen from eglibc)
  * add build deps to libgl1-mesa-dev and libgl-dev for armhf builds
  * add armel/armhf specific .install files since only a subset of modules can
    be built yet.

 -- Oliver Grawert <ogra@ubuntu.com>  Thu, 05 Apr 2012 19:09:27 +0200

compiz (1:0.9.7.4-0ubuntu1) precise; urgency=low

  * New upstream release
    - compiz crashed with SIGSEGV in CompositeScreen::compositingActive()
    - Window management - Closing one window sends others to the
      background (LP: #888704)
    - [regression] Invisible resize border is now only 1px wide (LP: #953839)
    - Coverity REVERSE_INULL - CID 10888 (LP: #957572)
    - Unity dash opens and immediately closes if you tap Super+A
      quickly (LP: #960831)
    - Unity 5.8: Flickering and corruption on Unity UI elements (LP: #963093)
    - Unity 5.8: Can't login to Unity since upgrade to 5.8 (LP: #963465)
    - [regression] Unity 5.8+Compiz 0.9.7.2: Pressing Super+Tab or
      Super+W works, but unity does not respond to when Super is
      released. (LP: #963470)
    - Unity 5.8: Login to blank screen (all black or just wallpaper)
      (LP: #963633)
    - Tests do not build when libgtest-dev is installed but libgtest
      isn't (LP: #964248)
    - Note that this fix is REMOVED for stability reasons:
       Unity/compiz intercepts Super and Alt keypresses from grabbed
       windows like VMs. (806255)
  * debian/patches/ubuntu-config.patch:
    - tweak slightly the shadow border for both active/inactive windows.
    - change the shortcuts as per design request: (LP: #969235)
      Ctrl + Super + D Minimises all windows
      Ctrl + Super + Cursor up Maximises the current window
      Ctrl + Super + Cursor down Restores or minimises current window
  * debian/rules, debian/compiz-gnome.gconf-defaults:
    - move the default for the unity-less default profile from DEFAULT_PLUGINS
      list as it seems compiz tries to load that list, then ccp, then the
      profile list.
    - put the active_plugins list back to the Default profile in gconf then.
  * debian/control:
    - set Standards-Version to latest
  * remove debian/patches/always_replace.patch,
    debian/patches/exit_1_if_composite_cant_init.patch,
    debian/patches/reset_active_plugin_list.patch,
    debian/reset-compiz-gconf, debian/compiz-gnome.install:
    - the 3 bad hacks are now not necessary anymore (LP: #963264)
  * remove as now in upstream tarball:
    - debian/patches/fix_953839.patch
    - debian/patches/revert_lim.patch
    - debian/patches/fix_953089_2.patch
    - debian/patches/fix_960831.patch

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 03 Apr 2012 15:43:16 +0200

compiz (1:0.9.7.2-0ubuntu4) precise; urgency=low

  * No-change upload to the release pocket instead of to -proposed, so we can
    get the package built on all archs immediately instead of it blocking on
    gtk+3.0's build on armel.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 26 Mar 2012 14:57:30 -0700

compiz (1:0.9.7.2-0ubuntu3) precise-proposed; urgency=low

  * debian/reset-compiz-gconf:
    - Fix crash in a new session

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 26 Mar 2012 20:35:33 +0200

compiz (1:0.9.7.2-0ubuntu2) precise-proposed; urgency=low

  * debian/patches/reset_active_plugin_list.patch:
    temporary wrapper from resetting the plugin list to the default.
    Uncorrect and unknown plugin makes various side effects, like removing
    plugins, creating hanging at startup and also creating on screen
    corruption. (LP: #963633)

 -- Didier Roche <didrocks@ubuntu.com>  Mon, 26 Mar 2012 18:41:09 +0200

compiz (1:0.9.7.2-0ubuntu1) precise-proposed; urgency=low

  [ Łukasz 'sil2100' Zemczak ]
  * New upstream snapshot:
    - Fix global menu not being ergonomical on large screens (LP: #682788)
    - Fix Alt+Right arrow key (LP: #943612)
    - Fix key bindings for actions while doing tap detection (LP: #944631)
    - Window movement is erratic and buggy, backport (LP: #923683)


=== debian/control ===
Source: compiz
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
Uploaders: David Nusinow <dnusinow@debian.org>, Sean Finney <seanius@debian.org>, Cyril Brulebois <kibi@debian.org>
Build-Depends: cmake (>= 2.6),
 debhelper (>= 7.0.50~), intltool, 
 libcairo2-dev,
 libdbus-glib-1-dev, libgconf2-dev, 
 libgl1-mesa-dev (>= 6.5.1) [!armhf !armel]| libgl-dev [!armhf !armel],
 libegl1-mesa-dev [armhf armel], libgles2-mesa-dev [armhf armel],
 libglib2.0-dev, libboost-serialization1.46-dev,
 libgtk2.0-dev, libgtk-3-dev, libice-dev (>= 1:1.0.1), 
 libmetacity-dev (>= 1:2.30.3-0ubuntu3), libpango1.0-dev, libpng12-dev | libpng-dev, librsvg2-dev, 
 libsm-dev (>= 1:1.0.1), libtool, libwnck-dev, libx11-dev, libxcomposite-dev (>= 1:0.3-2), libxext-dev,
 libxdamage-dev (>=1:1.0.3), libxfixes-dev (>= 1:4.0.1), libxinerama-dev, 
 libxml-parser-perl, libxrandr-dev (>= 2:1.1.0.2), libxrender-dev (>= 1:0.9.1), 
 libxcursor-dev,
 libxml2-dev, libxslt1-dev,
 libstartup-notification0-dev (>= 0.7),
 quilt (>= 0.40), x11proto-gl-dev (>= 1.4.8), xsltproc,
 libglu1-mesa-dev [!armhf !armel],
 libglib2.0-dev,
 libglibmm-2.4-dev,
 kde-workspace-dev, kdelibs5-dev (>= 4:4.2.2),
 metacity-common, libx11-xcb-dev,
 gnome-control-center-dev,
Standards-Version: 3.9.3
Vcs-Bzr: https://code.launchpad.net/~compiz/compiz/ubuntu

Package: compiz
Architecture: all
Provides: x-window-manager
Depends: compiz-core (>= ${source:Version}),
         compiz-plugins-default (>= ${source:Version}),
         compiz-gnome | compiz-kde,
         compiz-plugins-main-default (>= 0.9),
         libcompizconfig0 (>= 0.9.7.0~bzr428-0ubuntu2), ${misc:Depends}
Suggests: compizconfig-settings-manager
Description: OpenGL window and compositing manager
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This metapackage provides the components necessary for running compiz. It
 provides the compiz core, a set of standard plugins, a window decorator using
 the Gtk toolkit and the files necessary to integrate compiz with the GNOME
 desktop environment.

Package: compiz-core
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libcompizconfig0 (<< 0.9.5.94-0ubuntu2),
 compiz-fusion-plugins-main (<< 0.9.2.1-0ubuntu6), 
 unity (<< 4.2.0), 
 compiz-fusion-plugins-extra (<< 0.9),
 simple-ccsm (<< 0.9)
Recommends: compiz-plugins-default (= ${binary:Version})
Provides: compiz-core-abiversion-${coreabiversion}
Conflicts: compiz-wrapper (<< 1:0.8.4-0ubuntu4)
Replaces: compiz-wrapper (<< 1:0.8.4-0ubuntu4),
          compiz-gnome (<< 1:0.8.4-4ubuntu1)
Description: OpenGL window and compositing manager
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 Compiz combines together a window manager and a composite manager using
 OpenGL for rendering. A "window manager" allows the manipulation of the
 multiple applications and dialog windows that are presented on the screen. A
 "composite manager" allows windows and other graphics to be combined together
 to create composite images. Compiz achieves its stunning effects by doing
 both of these functions.

Package: compiz-dev
Architecture: any
Depends: compiz-core (= ${binary:Version}), ${misc:Depends}, libgl1-mesa-dev [!armhf !armel]| libgl-dev [!armhf !armel], libegl1-mesa-dev [armhf armel], libgles2-mesa-dev [armhf armel], libpng-dev, libgtk-3-dev, libxcomposite-dev (>= 1:0.3-2), libxfixes-dev (>=1:4.0.1), libxdamage-dev (>= 1:1.0.3), libxinerama-dev, libxrandr-dev (>=2:1.1.0.2), libxcursor-dev, libice-dev (>= 1:1.0.1), libsm-dev (>= 1:1.0.1), libstartup-notification0-dev (>= 0.7), libxslt1-dev, libxml2-dev, libx11-xcb-dev, libglib2.0-dev, libglibmm-2.4-dev, compiz-plugins (= ${binary:Version}), libdecoration0-dev
Description: OpenGL window and compositing manager - development files
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains the headers and libraries needed to compile compiz
 plugins.

Package: compiz-kde
Architecture: any
Depends: compiz-core (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
         compiz-plugins-default (= ${binary:Version}),
         compizconfig-backend-kconfig
Replaces: compiz-plugins (<< 1:0.9.4+bzr20110606-0ubuntu3)
Description: OpenGL window and compositing manager - KDE window decorator
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains a window decorator that uses KDE to provide a look and
 feel similar to that of the default KDE window manager.
 .
 NOTE: this package is empty for now. It needs some upstream maintenance to
 upgrade to a newer API. It will surely get removed soon if no enhancement
 is available.

Package: compiz-gnome
Architecture: any
Suggests: gnome-themes
Depends: ${shlibs:Depends}, ${misc:Depends},
         compiz-plugins-default (= ${binary:Version}),
         compizconfig-backend-gconf (>= 0.9.2.1git101213)
Replaces: compiz-plugins (<= 1:0.8.6-0ubuntu12),
          compiz-fusion-plugins-extra (<< 0.9.2.1-0ubuntu3),
Description: OpenGL window and compositing manager - GNOME window decorator
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains files needed to integrate compiz with the GNOME desktop
 environment.

Package: compiz-plugins-default
Architecture: any
Depends: compiz-core (= ${binary:Version}),
         libdecoration0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Replaces: compiz-plugins (<< 1:0.9.4+bzr20110606-0ubuntu3),
          compiz-gnome (<< 1:0.8.4-4ubuntu1),
          compiz-fusion-plugins-extra (<< 0.9.2.1-0ubuntu3)
Description: OpenGL window and compositing manager - default plugins
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains the default compiz plugins we activate in ubuntu coming
 with core compiz.

Package: compiz-plugins
Architecture: any
Depends: compiz-core (= ${binary:Version}),
         compiz-plugins-default (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Replaces: compiz-gnome (<< 1:0.8.4-4ubuntu1)
Description: OpenGL window and compositing manager - plugins
 Compiz brings to life a variety of visual effects that make the Linux desktop
 easier to use, more powerful and intuitive, and more accessible for users
 with special needs.
 .
 This package contains the standard plugins that come with compiz.

Package: libdecoration0
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Compiz window decoration library
 The window decoration library is responsible for drawing the window borders
 and title bar of windows managed by Compiz. It is used by window decorators
 like gtk-window-decorator and kde-window-decorator.

Package: libdecoration0-dev
Section: libdevel
Architecture: any
Depends: libdecoration0 (= ${binary:Version}), ${misc:Depends}, libx11-dev, libxrender-dev (>= 1:0.9.1)
Description: Compiz window decoration library - development files
 The window decoration library is responsible for drawing the window borders
 and title bar of windows managed by Compiz. It is used by window decorators
 like gtk-window-decorator and kde-window-decorator.
 .
 This package contains files required for developing window decorators
 compatible with Compiz.

## compiz 0.9.7.12

=== CMakeLists.txt ===
#
# Main CMakeLists.txt for compiz
#
project (compiz)

set (CMAKE_MODULE_PATH_ORIG ${CMAKE_MODULE_PATH})
set (COMPIZ_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${COMPIZ_CMAKE_MODULE_PATH})

# Common compiz CMake macros & functions.
include (CompizCommon)
# Packaging-specific CMake macros & functions.
include (CompizPackage)
include (cmake/base.cmake)
# Check if specific function is present in library.
include (CheckFunctionExists)

enable_testing()

# Import macro for doing coverage reporting
include(EnableCoverageReport)

#####################################################################
# Enable code coverage calculation with gcov/gcovr/lcov
# Usage:
#  * Switch build type to coverage (use ccmake or cmake-gui)
#  * Invoke make, make test, make coverage
#  * Find html report in subdir coveragereport
#  * Find xml report feasible for jenkins in coverage.xml
#####################################################################
IF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
  SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ftest-coverage -fprofile-arcs" )
ENDIF(CMAKE_BUILD_TYPE MATCHES [cC][oO][vV][eE][rR][aA][gG][eE])

#set (CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRe" CACHE INTERNAL "" FORCE)
#if (NOT CMAKE_BUILD_TYPE)
#    set (CMAKE_BUILD_TYPE "Debug" CACHE STRING "Build type (Debug/Release/RelWithDebInfo/MinSizeRe)" FORCE)
#endif (NOT CMAKE_BUILD_TYPE)

file (READ ${CMAKE_SOURCE_DIR}/VERSION COMPIZ_RELEASE_VERSION LIMIT 12 OFFSET 0)
string (STRIP ${COMPIZ_RELEASE_VERSION} COMPIZ_RELEASE_VERSION)

set (VERSION ${COMPIZ_RELEASE_VERSION})

set (DECOR_INTERFACE_VERSION 20110504)

if (COMPIZ_PACKAGING_ENABLED)
    set (prefix ${CMAKE_INSTALL_PREFIX}                   CACHE PATH "prefix")
    set (exec_prefix ${CMAKE_INSTALL_PREFIX}/bin          CACHE PATH "bindir")
    set (libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}  CACHE PATH "libdir")
    set (includedir ${CMAKE_INSTALL_PREFIX}/include       CACHE PATH "includedir")
    set (datadir ${CMAKE_INSTALL_PREFIX}/share            CACHE PATH "datadir")
else (COMPIZ_PACKAGING_ENABLED)
    set (prefix ${CMAKE_INSTALL_PREFIX}                 )
    set (exec_prefix ${CMAKE_INSTALL_PREFIX}/bin        )
    set (libdir ${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX})
    set (includedir ${CMAKE_INSTALL_PREFIX}/include     )
    set (datadir ${CMAKE_INSTALL_PREFIX}/share          )
endif (COMPIZ_PACKAGING_ENABLED)

set (compiz_plugindir ${libdir}/compiz)
set (compiz_sharedir ${datadir}/compiz/)
set (compiz_metadatadir ${datadir}/compiz)
set (COMPIZ_I18N_DIR ${CMAKE_SOURCE_DIR}/po)

# Translation
set (ALL_LINGUAS af ar bg bn bn_IN bs ca cs cy da de el en_GB en_US es eu et fi fr gl gu he hi hr hu id it ja ka km ko lo lt mk mr nb nl or pa pl pt pt_BR ro ru sk sl sr sv ta tr uk vi xh zh_CN zh_TW zu)
set (GETTEXT_PACKAGE compiz)

find_package (Boost 1.34.0 REQUIRED serialization)

set (COMPIZ_REQUIRES
    x11
    xext
    xdamage
    xcomposite
    x11-xcb
    xrandr
    xinerama
    xext
    ice
    sm
    libxml-2.0
    libxslt
    glib-2.0
    gio-2.0
    glibmm-2.4
    "libstartup-notification-1.0 >= 0.7"
)

set (DECORATION_REQUIRES xrender)

compiz_pkg_check_modules (COMPIZ REQUIRED ${COMPIZ_REQUIRES})
compiz_pkg_check_modules (LIBDECORATION REQUIRED ${DECORATION_REQUIRES})

list (APPEND COMPIZ_LIBRARIES ${Boost_LIBRARIES})

include (CompizDefaults)

set (COMPIZ_CFLAGS "${COMPIZ_CFLAGS} -I${Boost_INCLUDE_DIR}")

set (_compiz_package_string "Compiz ${VERSION}")
set (_compiz_package "Compiz")

compiz_configure_file (${compiz_SOURCE_DIR}/config.h.core.in ${compiz_BINARY_DIR}/generated/config.h)

compiz_configure_file (
    ${CMAKE_SOURCE_DIR}/compiz.pc.in
    ${CMAKE_BINARY_DIR}/compiz.pc
    COMPIZ_REQUIRES
    COMPIZ_CFLAGS
)

install (
    FILES ${CMAKE_BINARY_DIR}/compiz.pc
    DESTINATION ${COMPIZ_DESTDIR}${libdir}/pkgconfig
)

# Build Google Test and make its headers known
find_package (GTest)

if (NOT GTEST_FOUND)

    # Check for google test and build it locally
    set (GTEST_ROOT_DIR
	"/usr/src/gtest" # Default value, adjustable by user with e.g., ccmake
	CACHE
	PATH
	"Path to Google test srcs"
    )

    find_path (GTEST_INCLUDE_DIR gtest/gtest.h)

    if (GTEST_INCLUDE_DIR)
	#FIXME - hardcoded is bad!
	add_subdirectory (${GTEST_ROOT_DIR}
		      gtest)
    endif(GTEST_INCLUDE_DIR)

    set (GTEST_BOTH_LIBRARIES gtest gtest_main)
    set (GTEST_FOUND TRUE)

endif (NOT GTEST_FOUND)

find_library (GMOCK_LIBRARY gmock)
find_library (GMOCK_MAIN_LIBRARY gmock_main)

if (NOT GMOCK_LIBRARY OR NOT GMOCK_MAIN_LIBRARY OR NOT GTEST_FOUND)
  message ("Google Mock and Google Test not found - cannot build tests!")
  set (COMPIZ_BUILD_TESTING OFF)
endif (NOT GMOCK_LIBRARY OR NOT GMOCK_MAIN_LIBRARY OR NOT GTEST_FOUND)

include_directories (${GTEST_INCLUDE_DIRS})

find_package (Threads REQUIRED)

# Add the rest of compiz
add_subdirectory (cmake)
add_subdirectory (include)
add_subdirectory (images)
add_subdirectory (libdecoration)
add_subdirectory (gtk)
add_subdirectory (kde)
add_subdirectory (po)
add_subdirectory (metadata)
add_subdirectory (src)
add_subdirectory (xslt)
add_subdirectory (plugins)
add_subdirectory (tests)

compiz_ensure_linkage ()
compiz_package_generation ("Compiz")
compiz_add_uninstall ()
compiz_add_git_dist ()
compiz_add_distcheck ()
compiz_add_release ()
compiz_add_release_signoff ()

_print_configure_results ()

_check_compiz_cmake_macro (${CMAKE_MODULE_PATH_ORIG})

# Enable coverage reporting for compiz
enable_coverage_report()

=== cmake/CMakeLists.txt ===
compiz_configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/CompizDefaults.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/CompizDefaults.cmake
)

set (_files
    CompizCommon.cmake
    CompizPlugin.cmake
    CompizPackage.cmake
    CompizBcop.cmake
    ${CMAKE_CURRENT_BINARY_DIR}/CompizDefaults.cmake
)

list (APPEND _PluginExtensionFiles
      plugin_extensions/CompizGenInstallData.cmake)
list (APPEND _PluginExtensionFiles
      plugin_extensions/CompizGenInstallImages.cmake)

if (USE_GCONF)
    list (APPEND _files CompizGconf.cmake)
    list (APPEND _PluginExtensionFiles plugin_extensions/CompizGenGconf.cmake)
    list (APPEND _files CompizGSettings.cmake)
    list (APPEND _PluginExtensionFiles plugin_extensions/CompizGenGSettings.cmake)
endif (USE_GCONF)

install (
    FILES ${_files}
    DESTINATION ${COMPIZ_DESTDIR}${CMAKE_INSTALL_PREFIX}/share/compiz/cmake
)

install (
    FILES ${_PluginExtensionFiles}
    DESTINATION ${COMPIZ_DESTDIR}${CMAKE_INSTALL_PREFIX}/share/compiz/cmake/plugin_extensions
)

=== images/CMakeLists.txt ===

set (_images
    icon.png
)

install (
    FILES ${_images}
    DESTINATION ${COMPIZ_DESTDIR}${compiz_sharedir}
)

=== include/CMakeLists.txt ===
set (_headers
    decoration.h
)

install (
    FILES ${_headers}
    DESTINATION ${COMPIZ_DESTDIR}${includedir}/compiz
)

add_subdirectory (core)

=== libdecoration/CMakeLists.txt ===
compiz_pkg_check_modules (HAVE_XRENDER_0_9_3 xrender>=0.9.3)

configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/config.h.libdecoration.in
    ${CMAKE_CURRENT_BINARY_DIR}/config.h
)

include_directories (
    ${compiz_SOURCE_DIR}/include
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${LIBDECORATION_INCLUDE_DIRS}
)

add_definitions (
    -DHAVE_CONFIG_H
)

link_directories (
    ${LIBDECORATION_LINK_DIRS}
)

add_library (decoration SHARED
    decoration.c
)

set_target_properties (decoration PROPERTIES
    VERSION 0.0.0
    SOVERSION 0
)

target_link_libraries (
    decoration ${LIBDECORATION_LIBRARIES} m
)

install (
    TARGETS decoration
    DESTINATION ${COMPIZ_DESTDIR}${libdir}
)

set (DECORATION_LIBS "")
foreach (_val ${LIBDECORATION_LDFLAGS})
    set (DECORATION_LIBS "${DECORATION_LIBS}${_val} ")
endforeach (_val ${LIBDECORATION_LDFLAGS})

set (DECORATION_CFLAGS "")
foreach (_val ${LIBDECORATION_CFLAGS})
    set (DECORATION_CFLAGS "${DECORATION_CFLAGS}${_val} ")
endforeach (_val ${LIBDECORATION_CFLAGS})

compiz_configure_file (
    ${CMAKE_CURRENT_SOURCE_DIR}/libdecoration.pc.in
    ${CMAKE_CURRENT_BINARY_DIR}/libdecoration.pc
)

install (
    FILES ${CMAKE_CURRENT_BINARY_DIR}/libdecoration.pc
    DESTINATION ${COMPIZ_DESTDIR}${libdir}/pkgconfig
)

=== metadata/CMakeLists.txt ===
set (
    COMPIZ_DEFAULT_PLUGINS "core" CACHE STRING
    "Default plugins list that will be added to core metadata file"
)

find_program (XSLTPROC_EXECUTABLE xsltproc)
mark_as_advanced (FORCE XSLTPROC_EXECUTABLE)

if (XSLTPROC_EXECUTABLE)

    add_custom_command (
	OUTPUT ${compiz_BINARY_DIR}/generated/core.xml.in
	COMMAND ${XSLTPROC_EXECUTABLE}
		-o ${compiz_BINARY_DIR}/generated/core.xml.in
		--param default_plugins "\"'${COMPIZ_DEFAULT_PLUGINS}'\""
		${CMAKE_SOURCE_DIR}/xslt/default_plugins.xslt
		${CMAKE_CURRENT_SOURCE_DIR}/core.xml.in
	DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/core.xml.in
    )
    set (_core_file "${CMAKE_BINARY_DIR}/generated/core.xml.in")
else ()
    set (_core_file "${CMAKE_CURRENT_SOURCE_DIR}/core.xml.in")
endif ()

set (_xml_targets)
set (_schema_targets)

set (_core_xml_file ${CMAKE_BINARY_DIR}/generated/core.xml)
compiz_translate_xml (
    ${_core_file}
    ${_core_xml_file}
)

install (
    FILES ${_core_xml_file}
    DESTINATION ${COMPIZ_DESTDIR}${compiz_metadatadir}
)

add_custom_target (core-xml-file ALL
    DEPENDS ${_core_xml_file}
)

if (USE_GCONF)
    compiz_gconf_schema (
	${_core_xml_file}
	${CMAKE_BINARY_DIR}/generated/compiz-core.schemas
	${SCHEMADIR}
    )
    add_custom_target (core-gconf-schema ALL
	DEPENDS ${CMAKE_BINARY_DIR}/generated/compiz-core.schemas
	        core-xml-file
    )
endif ()
if (USE_GSETTINGS)
    compiz_gsettings_schema (
	${_core_xml_file}
	${CMAKE_BINARY_DIR}/generated/org.freedesktop.compiz.gschema.xml
	${datadir}/glib-2.0/schemas
    )
    add_custom_target (core-settings-schema ALL
	DEPENDS ${CMAKE_BINARY_DIR}/generated/org.freedesktop.compiz.gschema.xml
	        core-xml-file
    )
endif ()

=== plugins/CMakeLists.txt ===
set (COMPIZ_CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${COMPIZ_CMAKE_MODULE_PATH})
include (CompizDefaults)
include (CompizCommon)

set (COMPIZ_FOUND "true")

add_definitions ( -DHAVE_CONFIG_H)

include_directories( 
  ${CMAKE_CURRENT_SOURCE_DIR}/../include
  
  ${CMAKE_CURRENT_SOURCE_DIR}/../src
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/timer/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/string/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/pluginclasshandler/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/point/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/rect/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/window/geometry/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/window/geometry-saver/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/window/extents/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../src/window/constrainment/include
  ${CMAKE_CURRENT_SOURCE_DIR}/../logmessage/include
)

compiz_add_plugins_in_folder (${CMAKE_CURRENT_SOURCE_DIR})

=== po/CMakeLists.txt ===
project (po)

find_program (_intltool_update intltool-update)
mark_as_advanced (intltool_update)

find_program (_xgettext xgettext)
mark_as_advanced (_xgettext)

find_program (_msgmerge msgmerge)
mark_as_advanced (_msgmerge)

find_program(_msgfmt msgfmt)
mark_as_advanced (k3d_msgfmt)

set (compiz_catalogs ${ALL_LINGUAS})

set (compiz_catalog_targets)

add_custom_target (nls-update-sources
    ${_intltool_update} -m
    WORKING_DIRECTORY ${po_SOURCE_DIR}
)

add_custom_command (
    OUTPUT ${po_SOURCE_DIR}/compiz.pot
    COMMAND ${_intltool_update} --gettext-package compiz --pot
    DEPENDS POTFILES.in
    WORKING_DIRECTORY ${po_SOURCE_DIR}
)

foreach(catalog ${compiz_catalogs})
    add_custom_target (nls-update-${catalog}.po
	${_msgmerge} ${catalog} compiz -o ${catalog}.po --no-wrap
	DEPENDS ${po_SOURCE_DIR}/${catalog}.po
	WORKING_DIRECTORY ${po_SOURCE_DIR}
    )

    file (MAKE_DIRECTORY "${po_BINARY_DIR}/${catalog}/LC_MESSAGES")

    add_custom_command (
	OUTPUT ${po_BINARY_DIR}/${catalog}/LC_MESSAGES/compiz.mo
	COMMAND ${_msgfmt} -c -o ${po_BINARY_DIR}/${catalog}/LC_MESSAGES/compiz.mo ${po_SOURCE_DIR}/${catalog}.po
	DEPENDS ${po_SOURCE_DIR}/${catalog}.po
    )

    install (
	FILES ${po_BINARY_DIR}/${catalog}/LC_MESSAGES/compiz.mo
	DESTINATION ${COMPIZ_DESTDIR}${datadir}/locale/${catalog}/LC_MESSAGES
    )

    set (compiz_catalog_targets ${compiz_catalog_targets} ${po_BINARY_DIR}/${catalog}/LC_MESSAGES/compiz.mo)
endforeach(catalog)

add_custom_target(nls ALL
    DEPENDS ${po_SOURCE_DIR}/compiz.pot ${compiz_catalog_targets}
)

=== src/CMakeLists.txt ===
include (CompizBcop)


add_subdirectory( string )
add_subdirectory( logmessage )
add_subdirectory( timer )
add_subdirectory( pluginclasshandler )
add_subdirectory( point )
add_subdirectory( rect )
add_subdirectory( window )

IF (COMPIZ_BUILD_TESTING)
add_subdirectory( privatescreen/tests )
add_subdirectory( wrapsystem/tests )
add_subdirectory( region/tests )
add_subdirectory( plugin )
add_subdirectory( option/tests )
ENDIF (COMPIZ_BUILD_TESTING)

compiz_add_bcop_targets (
    core
    ${compiz_BINARY_DIR}/generated/core.xml.in
    _bcop_sources
)

get_property (CORE_MOD_INCLUDE_DIRS
	      GLOBAL
	      PROPERTY CORE_MOD_INCLUDE_DIRS)

include_directories (
    ${compiz_SOURCE_DIR}/include
    ${compiz_BINARY_DIR}
    ${compiz_BINARY_DIR}/generated
    ${COMPIZ_INCLUDE_DIRS}
    ${CMAKE_PREFIX_PATH}/include
    ${CMAKE_INCLUDE_PATH}
    ${CORE_MOD_INCLUDE_DIRS}
    
    ${CMAKE_CURRENT_SOURCE_DIR}
    
    # Module specific include dirs
    ${CMAKE_CURRENT_SOURCE_DIR}/string/include
    ${CMAKE_CURRENT_SOURCE_DIR}/string/src
    
    ${CMAKE_CURRENT_SOURCE_DIR}/logmessage/include
    ${CMAKE_CURRENT_SOURCE_DIR}/logmessage/src
    
    ${CMAKE_CURRENT_SOURCE_DIR}/timer/include
    ${CMAKE_CURRENT_SOURCE_DIR}/timer/src
    
    ${CMAKE_CURRENT_SOURCE_DIR}/pluginclasshandler/include
    ${CMAKE_CURRENT_SOURCE_DIR}/pluginclasshandler/src

    ${CMAKE_CURRENT_SOURCE_DIR}/point/include
    ${CMAKE_CURRENT_SOURCE_DIR}/point/src

    ${CMAKE_CURRENT_SOURCE_DIR}/rect/include
    ${CMAKE_CURRENT_SOURCE_DIR}/rect/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry-saver/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/geometry-saver/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/extents/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/extents/src

    ${CMAKE_CURRENT_SOURCE_DIR}/window/constrainment/include
    ${CMAKE_CURRENT_SOURCE_DIR}/window/constrainment/src
)

add_definitions (
    -DHAVE_CONFIG_H
    -DPLUGINDIR=\\\"${compiz_plugindir}\\\"
    -DSHAREDIR=\\\"${compiz_sharedir}\\\"
    -DMETADATADIR=\\\"${compiz_metadatadir}\\\"
)

get_property (CORE_MOD_LIBRARY_DIRS
	      GLOBAL
	      PROPERTY CORE_MOD_LIBRARY_DIRS)

link_directories (
    ${COMPIZ_LINK_DIRS}
    ${CORE_MOD_LIBRARY_DIRS}
    ${libdir}
)

add_library (compiz_core SHARED
    ${CMAKE_CURRENT_SOURCE_DIR}/global.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/region.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/atoms.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/actions.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/screen.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/window.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/action.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/option.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/match.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/event.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/session.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/output.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/size.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/windowgeometry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/icon.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/modifierhandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/propertywriter.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/eventsource.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/signalsource.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/stackdebugger.cpp

    ${_bcop_sources}
)

add_dependencies (core-options core-xml-file)
add_dependencies (compiz_core core-options)

#
# Normal libraries use the major version number of the library as their
# ABI version. But compiz uses funky date numbers for ABI revisions instead.
#
set (abiversion_h "${compiz_SOURCE_DIR}/include/core/abiversion.h")
file (STRINGS ${abiversion_h} abiline REGEX "^#define +CORE_ABIVERSION .+$")
string (REGEX REPLACE "#define +CORE_ABIVERSION +" "" abiversion "${abiline}")
set_target_properties (compiz_core PROPERTIES
    VERSION ${VERSION}
    SOVERSION "ABI-${abiversion}"
)

add_executable (compiz
    ${CMAKE_CURRENT_SOURCE_DIR}/main.cpp
)

# workaround for build race
add_dependencies (compiz core-xml-file)

get_property (CORE_MOD_LIBRARIES
	      GLOBAL
	      PROPERTY CORE_MOD_LIBRARIES)

target_link_libraries (
    compiz_core
    
    ${COMPIZ_LIBRARIES} 
    
    m 
    pthread 
    dl
    
    -Wl,-whole-archive
    compiz_string
    compiz_timer
    compiz_logmessage
    compiz_pluginclasshandler
    compiz_point
    compiz_rect
    compiz_window_geometry
    compiz_window_geometry_saver
    compiz_window_extents
    compiz_window_constrainment
    -Wl,-no-whole-archive
#    ${CORE_MOD_LIBRARIES}
)

#
# Tell CMake that targets using compiz_core should NOT re-import the
# libraries that compiz_core depends on (contains).
#
set_target_properties (compiz_core PROPERTIES
    LINK_INTERFACE_LIBRARIES ""
)

target_link_libraries (
    compiz
    compiz_core
)

install (
    TARGETS compiz_core
  	LIBRARY DESTINATION ${COMPIZ_DESTDIR}${libdir}
)

install (
    TARGETS compiz
    RUNTIME DESTINATION ${COMPIZ_DESTDIR}${exec_prefix}
)

enable_coverage_report( TARGETS compiz )

=== tests/CMakeLists.txt ===
if (COMPIZ_BUILD_TESTING)
add_subdirectory (integration)
endif (COMPIZ_BUILD_TESTING)

=== xslt/CMakeLists.txt ===

set (_files
    bcop.xslt
)

compiz_configure_file (compiz_gsettings_schemas.xslt.in compiz_gsettings_schemas.xslt)

if (USE_GCONF)
    list (APPEND _files compiz_gconf_schemas.xslt)
    list (APPEND _files ${CMAKE_CURRENT_BINARY_DIR}/compiz_gsettings_schemas.xslt)
endif ()

if (USE_GSETTINGS)
    
endif ()

install (
    FILES ${_files}
    DESTINATION ${COMPIZ_DESTDIR}${CMAKE_INSTALL_PREFIX}/share/compiz/xslt
)

=== gtk/gnome/CMakeLists.txt ===
if (BUILD_GNOME)
    set (desktop_file ${CMAKE_CURRENT_BINARY_DIR}/compiz.desktop)
    compiz_translate_desktop_file (
        ${CMAKE_CURRENT_SOURCE_DIR}/compiz.desktop.in
        ${desktop_file}
    )
    install (
	FILES ${desktop_file}
	DESTINATION ${COMPIZ_DESTDIR}${datadir}/applications
    )

    add_custom_target (compiz.desktop ALL SOURCES ${desktop_file})
endif (BUILD_GNOME)

=== debian/changelog ===
compiz (1:0.9.7.12-0ubuntu1) precise-proposed; urgency=low

  [ Łukasz 'sil2100' Zemczak ]
  * debian/patches/revert_fix_994841.patch, 
    debian/patches/revert_fix_933776_955035.patch
    - Removed, upstreamed
  * debian/watch:
    - Changed to the correct LP tarball path
  * debian/patches/compiz-package-gles2.patch:
    - Updated GLES patches to properly apply to the new compiz version

  [ Timo Jyrinki ]
  * New upstream release.
    - Compiz won't start if "unredirect fullscreen windows" is enabled 
      (LP: #980663)
    - "Unredirect Fullscreen Windows" stay on top (unredirected) even 
      when they're not on top any more (or the output is transformed) 
      (LP: #1041047)
    - Unredirect Fullscreen Windows sometimes fails to unredirect fullscreen 
      windows at all (LP: #1041066)
    - "Unredirect Fullscreen Windows" stay on top (unredirected) even when 
      an RGBA window is stacked above it (LP: #1046661)
    - scale mode is not visible if a fullscreen window is unredirected 
      (LP: #1047168)
    - Unredirecting a fullscreen window on a secondary monitor causes that
      monitor to flicker (LP: #1050749)
    - "Unredirect Fullscreen Windows" makes multi-monitor rendering much 
      slower (LP: #1051885)
    - [regression] Maximized window gets unredirected when it's not 
      fullscreen (LP: #1053902)
    - Unredirected fullscreen windows freeze and stay on top when wall 
      sliding (Ctrl+Alt+Left/Right) (LP: #1084401)
    - "Unredirect Fullscreen Windows" can cause significant tearing on 
      fullscreen windows (especially playing video) on some drivers
      (LP: #1051802)
    - HTML5 video in Firefox continues to tear (LP: #1086337)
    - Add support for blacklisting some drivers from using unredirected 
      fullscreen windows. By default intel and nouveau on Mesa 8.0 
      are blacklisted, configurable via ccsm. Users can upgrade to 
      Mesa 9.0 around 12.04.2 time. (LP: #1089246)
    - Unredirect fullscreen windows should be the default for optimal 
      performance (LP: #1063690)
  * debian/patches/workaround_broken_drivers.patch:
    - Updated to apply.
  * debian/patches/force_unredirect_enabling.patch:
    - Enable unredirect_fullscreen_windows unconditionally. Because of 
      gconf hurdles we can't easily migrate existing users into the 
      new default otherwise. Unredirection can be easily disabled with 
      the new unredirect_match option, by blanking it completely, 
      including removing the '(any)' part.
  * debian/patches/compiz-package-gles2.patch:
    - Update for the new blacklisting feature as well
  * debian/patches/blacklist_no_xml_double_escaping.patch:
    - Cherry-pick fix for the default string (LP: #1091103)

  [ Michael Terry ]
  * debian/patches/blacklist_no_xml_double_escaping.patch:
    - Update to also blacklist Mesa 9.0, which precise users may have from
      the x-updates PPA.  9.0 seems to have similar problems as 8.0 on
      Intel hardware.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Fri, 14 Dec 2012 10:41:24 +0200

compiz (1:0.9.7.8+bzr3121-0ubuntu1) precise-proposed; urgency=low

  * New upstream stable branch snapshot.
    - Includes all the previous cherry-picked fixes
    - Fix crash when imgsvg is loaded, due to missing symbol 
      (decor_apply_gravity from libdecoration). (LP: #956986)
    - Fix multiple window placement bugs (LP: #974242) (LP: #976032)
    - Fix window handle leak causing gradual degradation in desktop 
      performance (LP: #1050610)
    - Some decoration pixmaps get leaked on window resize, due to race 
      conditions between gtk-window-decorator and the decor plugin.
      (LP: #1057263)
    - Avoid a NULL dereference and give a useful error message instead.
      (LP: #944653)
    - Fix leakage of destroyed_pixmaps_table, containing pointers to freed 
      decor_t's which could result in a freed GHashTable being passed into 
      g_hash_table_remove and causing a crash. (LP: #1060171)
  * debian/patches/compiz-package-gles2.patch:
    - Drop the NEWS file, update decor.cpp part to build with new upstream
      code.
  * debian/patches/revert_fix_933776_955035.patch:
    - Cherry-pick the revert from upstream since the bug fix is not 
      suitable for SRU as is
  * debian/patches/revert_fix_994841.patch:
    - Cherry-pick also this revert as non-SRU material, not relevant 
      to users
  * debian/libdecoration0.symbols:
    - Update with latest symbols

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Mon, 12 Nov 2012 13:56:29 +0200

compiz (1:0.9.7.8-0ubuntu1.4) precise-proposed; urgency=low

  [ Steve Langasek ]
  * debian/patches/compiz-package-gles2.patch: refresh to account for
    fix_1012956.patch, which introduces non-GLES2 objects that need to be
    patched back out for ARM.  LP: #1032902.

 -- Timo Jyrinki <timo-jyrinki@ubuntu.com>  Tue, 07 Aug 2012 12:32:27 +0300

compiz (1:0.9.7.8-0ubuntu1.3) precise-proposed; urgency=low

  [ Łukasz 'sil2100' Zemczak ]
  * Cherry-pick upstream patches:
    - CMake Error at FindCompiz.cmake:84 (include): include could not find load
      file: CompizDefaults (LP: #993608)
    - compiz (decor) - Warn: failed to bind pixmap to texture (LP: #929989)
    - gtk-window-decorator crashed with SIGFPE in 
      _decor_blend_horz_border_picture() (LP: #963794)
    - [callgrind] compiz spends ~25% of its time constructing/destructing 
      strings in PrivateScreen::handleActionEvent (LP: #1005569)
    - gtk-window-decorator crashed with SIGSEGV in meta_get_decoration_geometry
      (LP: #1007754)
    - composite refresh rate falls back to 50Hz, which is wrong in most cases
      (LP: #1009338)
    - [callgrind] compiz spends ~7% of its time inserting into and destructing 
      the events list in PrivateScreen::processEvents() (LP: #1006335)
    - It is possible for a dock shadow to be painted even if the dock window 
      isn't painted (LP: #1012956)

  [ Timo Jyrinki ]
  * Cherry-pick upstream patches:


=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
  metacity-common, libx11-xcb-dev,
  gnome-control-center-dev,
 Standards-Version: 3.9.3
-Vcs-Bzr: https://code.launchpad.net/~compiz/compiz/ubuntu
+Vcs-Bzr: https://code.launchpad.net/~ubuntu-desktop/compiz/precise
 
 Package: compiz
 Architecture: all

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)
gles2_architectures := armel armhf

CORE_ABIVERSION := $(shell sed -rn 's/^\#define[[:space:]]+CORE_ABIVERSION[[:space:]]+//p' include/core/abiversion.h )

DEFAULT_PLUGINS = "ccp"

override_dh_quilt_patch:
	dh_quilt_patch
	if test -r debian/patches/series.$(DEB_HOST_ARCH); then \
	  pc=".pc.$(DEB_HOST_ARCH)"; \
	  test -d "$(CURDIR)/$$pc" || mkdir "$(CURDIR)/$$pc"; \
	  cp debian/patches/series.$(DEB_HOST_ARCH) $(CURDIR)/$$pc/series; \
	  cd $(CURDIR); \
	  QUILT_PC="$$pc" quilt upgrade || true; \
	  QUILT_PC="$$pc" QUILT_PATCHES="debian/patches/" quilt push -a || true; \
	fi; \

override_dh_quilt_unpatch:
	if test -r debian/patches/series.$(DEB_HOST_ARCH); then \
	  pc=".pc.$(DEB_HOST_ARCH)"; \
	  cd $(CURDIR); \
	  QUILT_PC="$$pc" QUILT_PATCHES="debian/patches/" quilt pop -a || true; \
	fi; \
	dh_quilt_unpatch

override_dh_auto_configure:
	# currently, segfault if CMAKE_BUILD_TYPE=Release
	LDFLAGS=$(shell echo $$LDFLAGS | sed -e 's/\-Wl,-Bsymbolic-functions //')
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
	dh_auto_configure -- -DCOMPIZ_BUILD_WITH_RPATH=FALSE -DCOMPIZ_DEFAULT_PLUGINS=\"$(DEFAULT_PLUGINS)\" -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCOMPIZ_PACKAGING_ENABLED=TRUE -DUSE_GSETTINGS=OFF -DCOMPIZ_DISABLE_GS_SCHEMAS_INSTALL=ON -DCOMPIZ_DISABLE_PLUGIN_KDE=ON -DCOMPIZ_BUILD_TESTING=OFF -DUSE_KDE4=OFF -DBUILD_GLES=ON
else
	dh_auto_configure -- -DCOMPIZ_BUILD_WITH_RPATH=FALSE -DCOMPIZ_DEFAULT_PLUGINS=\"$(DEFAULT_PLUGINS)\" -DCMAKE_BUILD_TYPE=RelWithDebInfo -DCOMPIZ_PACKAGING_ENABLED=TRUE -DUSE_GSETTINGS=OFF -DCOMPIZ_DISABLE_GS_SCHEMAS_INSTALL=ON -DCOMPIZ_DISABLE_PLUGIN_KDE=ON -DCOMPIZ_BUILD_TESTING=OFF -DUSE_KDE4=OFF
endif

override_dh_install:
	# Language packs
	for d in $$(find debian/tmp -type f \( -name "*.desktop" -o -name "*.directory" \) ); do \
		sed -ri '/^(Name|GenericName|Comment|X-GNOME-FullName)\[/d' $$d; \
		echo "X-Ubuntu-Gettext-Domain=compiz" >> $$d; \
	done;
	#for d in $$(find debian/tmp -type f -name "*.schemas" ); do \
	#		GETTEXT_DOMAIN="compiz" perl /usr/lib/cdbs/strip-schema.pl $$d > $$d.new; mv $$d.new $$d; \
	#done;

	# create compiz keybindings file based on the metacity ones.
	mkdir -p $(CURDIR)/debian/tmp/usr/share/gnome-control-center/keybindings/
	# keep package=metacity to get the right translation :)
	for i in launchers navigation screenshot system windows ; do \
	    sed 's/wm_name=\"Metacity\"/wm_name=\"Compiz\"/' /usr/share/gnome-control-center/keybindings/50-metacity-$${i}.xml > $(CURDIR)/debian/tmp/usr/share/gnome-control-center/keybindings/50-compiz-$${i}.xml ; \
    done
	# add some selected keys
	sed -i 's#key=\"/apps/metacity/general/num_workspaces\" comparison=\"gt\"##g' $(CURDIR)/debian/tmp/usr/share/gnome-control-center/keybindings/50-compiz-navigation.xml
    # TODO: checking and bending those key to a compiz equivalent (or move the blessed option to g-c-c)
	#sed -i 's#description="Toggle magnifier">#description="Toggle magnifier">/apps/compiz-1/plugins/scale/screen0/options/initiate_key#g' $(CURDIR)/debian/tmp/usr/share/gnome-control-center/keybindings/50-compiz-accessibility.xml
	#sed -i 's#description="Magnifier zoom in">#description="Magnifier zoom in">/apps/compiz-1/plugins/ezoom/screen0/options/zoom_in_key#g' $(CURDIR)/debian/tmp/usr/share/gnome-control-center/keybindings/50-compiz-accessibility.xml
	#sed -i 's#description="Magnifier zoom out">#description="Magnifier zoom out">/apps/compiz-1/plugins/ezoom/screen0/options/zoom_out_key#g' $(CURDIR)/debian/tmp/usr/share/gnome-control-center/keybindings/50-compiz-accessibility.xml

	# cmake findcompiz_install use COMPIZ_DESTDIR and using COMPIZ_DESTDIR and
	# DESTDIR together is completely broken upstream
	# So, doing the same in debian/rules to find a way to install things in the
	# right place, sorry for the kittens
ifeq ($(DEB_HOST_ARCH),$(findstring $(DEB_HOST_ARCH), $(gles2_architectures)))
	cmake_dir=`cmake --system-information 2> /dev/null | grep "^CMAKE_ROOT " | sed -e 's/.*"\(.*\)"/\1/'` && \
	mkdir -p debian/tmp$${cmake_dir}/Modules && \
	cp cmake/FindCompiz.cmake debian/tmp$${cmake_dir}/Modules && cp cmake/FindOpenGLES2.cmake debian/tmp$${cmake_dir}/Modules
else
	cmake_dir=`cmake --system-information 2> /dev/null | grep "^CMAKE_ROOT " | sed -e 's/.*"\(.*\)"/\1/'` && \
	mkdir -p debian/tmp$${cmake_dir}/Modules && \
	cp cmake/FindCompiz.cmake debian/tmp$${cmake_dir}/Modules
endif

	# remove .a files
	rm -f debian/tmp/usr/lib/*.a

	dh_install --fail-missing

override_dh_gencontrol:
	dh_gencontrol -- -Vcoreabiversion=$(CORE_ABIVERSION)

override_dh_auto_test:
	# test broken right now :(

%:
	dh --with quilt $@

=== debian/watch ===
version=3
https://launchpad.net/compiz-core/+download .*/compiz-core-([0-9.]+)\.tar\.bz2
